(*********************************************************
  Sparing: 6 listopada 2004
  Zadanie: C - Taksowkarz
  Autor:   Wladyslaw Bodzek
*********************************************************)

{$MODE DELPHI}
{$R+, S+}

const 
  MAXN = 100000;
  
//  adds : array[0..7,0..4] of Integer = 
//    ( (0,6,8,4), (4,0,2,4), (4,0,2,4), (4,4,0,2), (4,6,6,2), (4,6,6,2), (4,6,8,4), (4,8,8,4) );
  
var 
  nsets, iset, i, j, k, n : Integer;
  x, y : array[0..MAXN] of Integer;
  c, c2 : array [0..3] of QWord;
  d, val : QWord;
  modifs : array[0..3,0..3,0..7] of Integer;
  
(*
procedure prepare;
  var
    t : array[
begin
end;
*)

procedure prepare;
  const
    moves : array[0..3,0..1,0..1] of Integer = 
      ( ((0,1),(1,0)), ((1,0),(0,-1)), ((0,-1),(-1,0)), ((-1,0),(0,1)) );
  var
    i, j, k, l, xx : Integer;
    t : array[-2..2,-2..2,0..3] of Integer;
    tis : array[-3..3,-3..3,0..3] of Boolean;
    q : array[0..500,0..2] of Integer;
    q_st, q_end : Integer;
  procedure enqueue( a, b, c : Integer; dist : Integer );
  begin
    q[q_end,0] := a;
    q[q_end,1] := b;
    q[q_end,2] := c;
    inc(q_end);
    tis[a,b,c] := true;
    t[a,b,c]   := dist;
  end;
  procedure dequeue( var a, b, c : Integer );
  begin
    a := q[q_st,0];
    b := q[q_st,1];
    c := q[q_st,2];
    inc(q_st);
  end;
begin
  for xx := 0 to 3 do begin
    for i := -3 to 3 do
      for j := -3 to 3 do
        for k := 0 to 3 do
          tis[i,j,k] := (i=3)or(i=-3)or(j=3)or(j=-3);

    q_st := 0;
    q_end := 0;
    enqueue(0,0,xx,0);
  
    while q_st <> q_end do begin
      dequeue(i,j,k);
      if not tis[i+moves[k,0,0],j+moves[k,0,1],k] then
        enqueue(i+moves[k,0,0],j+moves[k,0,1],k,t[i,j,k]+1);
      if not tis[i+moves[k,1,0],j+moves[k,1,1],(k+1) mod 4] then
        enqueue(i+moves[k,1,0],j+moves[k,1,1],(k+1) mod 4,t[i,j,k]+1);
    end;
    for i := 0 to 3 do begin
      modifs[xx,i,0] := t[0, 1, i] - 1;
      modifs[xx,i,1] := t[1, 1, i] - 2;
      modifs[xx,i,2] := t[1, 0, i] - 1;
      modifs[xx,i,3] := t[1, -1,i] - 2;
      modifs[xx,i,4] := t[0, -1,i] - 1;
      modifs[xx,i,5] := t[-1,-1,i] - 2;
      modifs[xx,i,6] := t[-1,0, i] - 1;
      modifs[xx,i,7] := t[-1,1, i] - 2;
    end;
  end;
end;

procedure printmodifs;
  var
    i, j, k : Integer;
begin
  for i := 0 to 3 do begin
    for j := 0 to 3 do begin
      write('(');
      for k := 0 to 7 do begin
        write(modifs[i,j,k]);
	if k <> 7 then 
	  write(',');
      end;
      write(')  ');
    end;
    writeln;
  end;
end;

function direction( x1, y1, x2, y2 : Integer ):Integer;
begin
  if x2 > x1 then begin
    if y2 > y1 then
      Result := 1
    else if y2 = y1 then
      Result := 2
    else
      Result := 3;
  end else if x2 = x1 then begin
    if y2 > y1 then
      Result := 0
    else if y2 = y1 then
      Result := -1
    else
      Result := 4;
  end else begin
    if y2 > y1 then
      Result := 7
    else if y2 = y1 then
      Result := 6
    else
      Result := 5;
  end;
end;

procedure checkandset( i, j : Integer; val : QWord );
begin
  if (i = 0) or (c2[j] > val) then
    c2[j] := val;    
end;

begin
  prepare;
//  printmodifs;
  
  readln(nsets);
  for iset := 1 to nsets do begin
    readln(x[0],y[0]);
    readln(n);
    for i := 1 to n do
      readln(x[i],y[i]);
      
    for i := 0 to 3 do
      c[i] := 0;
      
    for i := 1 to n do 
      if (x[i-1] <> x[i]) or (y[i-1] <> y[i]) then begin
        d := QWord(abs(x[i-1]-x[i]))+QWord(abs(y[i-1]-y[i]));
//        writeln('POINT #',i,' d=',d,' (',x[i-1],',',y[i-1],')->(',x[i],',',y[i],')');
//        writeln('    ',c[0],',',c[1],',',c[2],',',c[3]);
        for j := 0 to 3 do begin
          for k := 0 to 3 do begin
	    val := c[j]+d+modifs[j,k,direction(x[i-1],y[i-1],x[i],y[i])];
// 	    write('(',direction(x[i-1],y[i-1],x[i],y[i]),'=>',val:5,') ');
	    checkandset(j,k,val);
	  end;
//  	  writeln;
        end;
        c := c2;
      end;
    
    d := c[0];
    for i := 1 to 3 do
      if c[i] < d then
        d := c[i];
	
    writeln(d);   
  end;
end.